#!/usr/bin/perl 
# DirPorts v0.5
# portdir.pl v0.5
# By Gianmarco Giovannelli (gmarco@giovannelli.it)
# an happy survivour of the :
# P-Day, C-Day, B-Day, E-Day, R-Day, lib.blabla-Day


use CGI qw(:standard :html3 :netscape);

require "addon.pl";

$dirname=param("dirname");
$querystring=param("querystring");
$qfield=param("qfield");
$timerstart= (times)[0];
  

if ($dirname ne "" && $querystring eq "" && $qfield eq ""){
  
  foreach $file (<$basepath/$dirname/*>) {
    if (-d $file && $file ne "pkg"){
      $basename=basename($file);
      push(@dirs,$basename);
#      $desc{$basename}=catxt("$file/pkg-comment");
#	$desc{$basename}=substr(`grep COMMENT $file/Makefile | head -n 1`,7);
      
	if (-e "$file/pkg-comment"){
      		$desc{$basename}=catxt("$file/pkg-comment");
	} else {	
		$desc{$basename}=substr(`grep COMMENT $file/Makefile | head -n 1`,8);
        }
	$fullpath{$basename}=$file;
        $url{$basename}="$dirname/$basename";
    }
  }
  
  print header(),"\n", start_html(-title =>"Ports", -bgcolor=>$bgcolor),"\n";
  print basefont({-size=>$bfs, -face=>$fontface});
  
  print h1("The FreeBSD Ports Collection: \"$dirname\""),"\n";
  print hr(),p("You are now in the directory ".b($dirname).". [ ".($#dirs+1)." ] ports here.");


} else {

  if($qfield eq "name\, path and desc"){
    @index=("0","1","3");
  }

if($qfield eq "mantainer"){
  @index=("5");
}

open(INDEX,$basepath."/INDEX");

while ($line = <INDEX>){
  @fields = split(/\|/, $line);
  
  if ("@fields[@index]" =~ /$querystring/i && $fields[1] !~ /$ignoredirs/i ){  
    
#    $fields[1]      =  /usr/ports/games/pmars
#    $basename       = pmars
#    $url{$basename} = games/pmars

    $basename=basename($fields[1]);
    push(@dirs,$basename);

	if (-e "$fields[1]/pkg-comment"){
      		$desc{$basename}=catxt("$fields[1]/pkg-comment");
	} else {	
		$desc{$basename}=substr(`grep COMMENT $fields[1]/Makefile | head -n 1`,8);
        }

    $fullpath{$basename}=$fields[1];
    $url{$basename}= substr($fields[1],length($basepath)+1);
      
    if ($#dirs >= $maxqresults){
      last;
    }
  }
}

  print header(),"\n", start_html(-title =>"Ports", -bgcolor=>$bgcolor),"\n";
  print basefont({-size=>$bfs, -face=>$fontface});
  
  print  h1("The FreeBSD Ports Collection"),"\n";
  print hr(),"\n";
  print p(font({-size=>$bfs, -face=>$fontface},
	       "Active ports found using filter ".b($querystring)." in ".b($qfield)." field are ".($#dirs+1))),"\n";
  
}

###### Last (and common) generation part #########

print table({-bgcolor=>"$bgcolor", -border=>"$tableborder", -width=>"95%", -align=>"CENTER"}),"\n";
print Tr(th({-align=>"left"},['Name','M.Time','Description']));

foreach $entry (@dirs){
    print Tr();

    print td({-align=>"LEFT", -colspan=>"1", -width=>"15%", -bgcolor=>"$bgcolor"},
	     font({ -size=>"$bfs", -face=>"$fontface",-color=>"$fontcolor"}),
	     a({href=>"./pkg.pl?dirname=".CGI->escape($url{$entry})}),$entry),"\n";

    print td({-align=>"LEFT", -colspan=>"1", -width=>"15%", -bgcolor=>"$bgcolor"},
	     font({ -size=>"$bfs", -face=>"$fontface",-color=>"$fontcolor"}),
	     modate($fullpath{$entry})."\n");

    if (-M   $fullpath{$entry} <= $daysarrived){ 
      print td({-align=>"LEFT", -colspan=>"1", -width=>"70%", -bgcolor=>"$bgcolor"},
	       font({ -size=>"$dfs", -face=>"$fontface",-color=>"$fontcolor"}),b($desc{$entry})."\n");
    } else {
      print td({-align=>"LEFT", -colspan=>"1", -width=>"70%", -bgcolor=>"$bgcolor"},
	       font({ -size=>"$dfs", -face=>"$fontface",-color=>"$fontcolor"}),$desc{$entry}."\n");
    }
  }
print "</TABLE>\n";

print "\n",hr(),
  table({-align=>"left",-width=>"100%"},
	Tr(
	   td({-align=>"left"}, font({-size=>$pfs, -face=>$fontface},
				     a({href=>"./index.pl"},"Return to main page"))),
	   td({-align=>"right"},font({-size=>$pfs, -face=>$fontface},
				     sprintf("Page generation time : %.2f secs",(times)[0]-$timerstart)))
	  )
       );
print  end_html();  


