# Simple Config
# for DirPorts.pl v0.5
# 
# addon.pl v0.5
#
# By Gianmarco Giovannelli (gmarco@giovannelli.it)
# an happy survivour of the :
# P-Day, C-Day, B-Day, E-Day, R-Day, lib.blabla-Day
# :-)

require Exporter;

### BaseFont, PackageFontSize, DescFontSize
$bfs = 1; 
$pfs = 1;
$dfs = 1;

### Border of the table ?
# 0 = off
# any other number is the width of the border

$tableborder = 0;

### Cosmetics
$fontface = "Verdana, Clean, Helvetica"; 
$bgcolor = "#ada195";
$vlink = "green";
$fontcolor = "black";

### Base Path for port dir
$basepath = "/usr/ports";	

### Ignore searched line containing ...
$ignoredirs = "french|hebrew|hungarian|japanese|korean|german|chinese|portuguese|ukrainian|vietnamese|russian|distfiles|Mk|tools|Templates";

### Max search results 
$maxqresults = 180;

### Old days 
$daysarrived = 3;

### Date
# datetype = 1 -> 31 Dec 1999
# datetype = 2 -> Fri, 31 Dec 1999
# datetype = 3 -> 1999 12 31
# datetype = 4 -> 31 12 1999
# datetype = 5 -> 1999 12

$datetype = 4;

### Verbose mode
$verbose = false;



######################################################
### Various sub, beware to change anything below here# 
######################################################
sub basename {
	($dummy=$_[0]) =~ s#.*/##s;
	return $dummy;
}
################################################
sub catxt {
	$dummy=(`cat $_[0]`);
	chomp $dummy;
	return $dummy;
}

################################################
sub modate {

  @filestat = stat($_[0]);
  @day=(Sun, Mon, Tue, Wed, Thu, Fri, Sat);
  @month=(Jan, Feb, Mar, Apr, May, Jun, Jul, Aug, Sep, Oct, Nov, Dec);
  
  ($min, $hour, $mday, $mon, $year, $wday) = (localtime((@filestat)[10]))[1,2,3,4,5,6]; 
  
 

  if ($datetype==1){	
    return $mday." ".$month[$mon]." ".($year+1900);
  }

  if ($datetype==2){
    return $day[$wday]." ,".$mday." ".$month[$mon]." ".($year+1900);
  }
  
  if ($datetype==3){	
    return ($year+1900)." ".($mon+1)." ".$mday;
  }
  
  if ($datetype==4){
    return $mday." ".($mon+1)." ".($year+1900);
  }

  if ($datetype==5){
    return ($year+1900)." ".($mon+1);
  }
  
  



}
################################################
sub stripnp {
	
	($dummy=$_[0]) =~ tr/\r\t\n//d;
	return $dummy;

}
################################################
sub convmacro {
  
  $dummy=$_[0];

    ($dummy)=~s/\$\{EXTRACT_SUFX\}/$suffix/;
    ($dummy)=~s/\$\{DISTNAME\}/$distname/;
    ($dummy)=~s/\$\{DATE\}/$date/;
    ($dummy)=~ tr/ \t\n//d;
	return $dummy;
}
